#include <sys/types.h>
#include <signal.h>
#include <termios.h>
#include <unistd.h>
#include <curses.h>
#include <err.h>
#include "ice.h"
#include "dir.h"
#include "edit/ne.h"
#include <syslog.h>

void ice_init_f7_console(void)
{
	int i;
	for(i=0;i<256;i++)
	{
		ice_console.f7_line[i]=0;
		ice_console.f7_line2[i]=0;
	}				
	ice_console.f7_start=ice_console.f7_pos=ice_console.f7_length=0;
}



void GetCommandBuffer(void)
{
	int i = 0, j ;

    char buff1 [256];
    char buff2 [256];

	for(i=0;i<256;i++)
	{
		buff1[i]=0;
		buff2[i]=0;
	}

	for(i=0;i<256;i++)
	{
		if(ice_console.f7_line[i]!=0)
		{
			for(j=0;j<66;j++)
			{
				if(ice_console.f7_line[i]==ice_console.key_symbols1[j] && ice_console.f7_line2[i]==ice_console.key_symbols2[j] )
				{
					buff1[i]=ice_console.utf_symbols1[j];	
					buff2[i]=ice_console.utf_symbols2[j];	
					break;
				}
			}
		}
		else 
		{
			buff2[i]=ice_console.f7_line2[i];	
		}
	}


	int count=0;
	for(i=0;i<256;i++)
	{
		if(buff1[i]!=0)
		{	
			ice_console.f7_buf[count]=buff1[i];
			count++;
			ice_console.f7_buf[count]=buff2[i];
			count++;
		}	
		else
		{
			ice_console.f7_buf[count]=buff2[i];
			count++;
		}	
	}
}


void GetMainCommandBuffer(void)
{
	int i = 0, j ;

    char buff1 [512];
    char buff2 [512];

	for(i=0;i<512;i++)
	{
		buff1[i]=0;
		buff2[i]=0;
	}

	for(i=0;i<512;i++)
	{
		if(ice_console.main_line[i]!=0)
		{
			for(j=0;j<66;j++)
			{
				if(ice_console.main_line[i]==ice_console.key_symbols1[j] && ice_console.main_line2[i]==ice_console.key_symbols2[j] )
				{
					buff1[i]=ice_console.utf_symbols1[j];	
					buff2[i]=ice_console.utf_symbols2[j];	
					break;
				}
			}
		}
		else 
		{
			buff2[i]=ice_console.main_line2[i];	
		}
	}


	int count=0;
	for(i=0;i<512;i++)
	{
		if(buff1[i]!=0)
		{	
			ice_console.main_buf[count]=buff1[i];
			count++;
			ice_console.main_buf[count]=buff2[i];
			count++;
		}	
		else
		{
			ice_console.main_buf[count]=buff2[i];
			count++;
		}	
	}
}


bool dialog_action(char * _name , int _action , bool _save , char * str1 , char * str2) 
{

	int c;
  	char line [512];
  	char * _line = line;

	switch(_action) 
		{
			case 1:
				sprintf(line," Удалить %s ?",_name);
				draw_dialog(_save , _line);
				break;
			case 2:
				sprintf(line," Файл был изменен. Сохранить  ");
				draw_dialog(_save,_line);
				break;
			case 3:
				draw_dialog_warning(_name); // копирование невозможно
				return _save;
				break;
			case 4: // копирование f5 - f6
				draw_dialog_f5(_save , str1 , str2 ); 
				break;
			case 5: // help f1
				draw_dialog_f1(_name ); 
				break;
			case 6: // menu f2
				draw_dialog_f2(_name ); 
				break;
			case 7: // menu f9
				cur_panel->pos_menu=0;
				draw_dialog_f9(_name ); 
				break;
			default:
				break;
		}

	

	while(TRUE) {

	
		c = ice_key_code ();

		switch(c) {
				case 257: // up
					if(_action==7)
					{
						if(cur_panel->pos_menu>0)
						{
							cur_panel->pos_menu--;
							draw_dialog_f9(_name ); 
						}
					}
					break;
				case 258: // down
					if(_action==7)
					{
						if(cur_panel->pos_menu<6)
						{
							cur_panel->pos_menu++;
							draw_dialog_f9(_name ); 
						}
					}
					break;
				case 259: // left
					if(!_save) _save=TRUE;
					else _save=FALSE;
					if(_action==4) draw_dialog_f5(_save , str1 , str2 ); 
					else draw_dialog(_save,_line);
					break;

				case 260: // right
					if(_save) _save=FALSE;
					else _save=TRUE;
					if(_action==4) draw_dialog_f5(_save , str1 , str2 ); 
					else draw_dialog(_save,_line);
					break;

				case 13:		// Enter
					if(_action==6) // F2
					{
						UpdateColor();
					}
					if(_action==7) // F9
					{
						if(cur_panel->pos_menu<2) // list type
						{							
							cur_panel->list_type=cur_panel->pos_menu; 
							cur->curfile=cur->topfile=0;
						}
						else if(cur_panel->pos_menu<6) // sort type
						{
							cur_panel->sort_type=cur_panel->pos_menu-2;
							cur->sort = cur_panel->sort_type+1;
							setdir (cur,cur->cwd);
						}
						else  // reverse
						{
							if(cur_panel->reverse) cur_panel->reverse=FALSE ;
							else cur_panel->reverse=TRUE; 
							cur->revsort ^= 1;
							setdir (cur,cur->cwd);
						}
					}
						return _save;
					break;

				case 513:		// F1
				case 514:		// F2
				case 515:		// F3
				case 516:		// F4
				case 517:		// F6
				case 518:		// F7
				case 519:		// F8
				case 520:		// F9
				case 521:		// F10
				case 522:		// F11
				case 523:		// F12
				case 275:		// del
					break;
				case 27:
					return FALSE;
					break;
				default:
					return  _save;
					break;
		}
	}
	return _save;
}


int InitLine(void)
{
		int i=0,j=0;
		int len_buf = strlen(ice_console.f7_buf);
		int _utf1 = 0 ;
		int _utf2 = 0 ;
		int count = 0 ;
		int pos = 0 ;


	for(i=0;i<len_buf;i++)
	{
		if(ice_console.f7_buf[i]<0)
		{
			if(count==0) _utf1=ice_console.f7_buf[i];
			else if(count==1)
			{
				for(j=0;j<66;j++)
				{
					if(ice_console.f7_buf[i] == ice_console.utf_symbols2[j] && _utf1== ice_console.utf_symbols1[j]) 
					{
						_utf2=j;
						ice_console.f7_line[pos]=ice_console.key_symbols1[_utf2];
						ice_console.f7_line2[pos]=ice_console.key_symbols2[_utf2];
						pos++;
					}
				}
			}
			count++;
			if(count==2) count=0;
		}
		else 
		{
			ice_console.f7_line[pos]=0;
			ice_console.f7_line2[pos]=ice_console.f7_buf[i];
			pos++;
			count=0;
		}
	}

	return pos;

}


bool dialog_action_f7(char * caption) 
{
	int i ,  key;
//	unsigned char  *p;
	int  _utf_code = 0;
// 	char line [512];

	ice_init_f7_console();

	if (mystrcmp(ice_console.f7_buf, "")==1) 
	{
		ice_console.f7_length = ice_console.f7_pos = InitLine();
	}

	draw_dialog_f7(ice_console.f7_pos,caption);

	while(TRUE) 
	{
		key = ice_key_code ();
		if((key==208)||(key==209)) 	
		{
			_utf_code=key;
			if(ice_console.f7_pos<ice_console.f7_length)		
			{	
				for(i=254;i>=ice_console.f7_pos;i--)
				{
					ice_console.f7_line[i+1]=ice_console.f7_line[i];
				}
			}
			ice_console.f7_line[ice_console.f7_pos]=key;
			continue;
		}
		else
		{
			if((key!=259)&&(key!=260)&&(key!=263)&&(key!=264)&&(key!=272)&&(key!=275)&&(key!=13))
			{
				if(ice_console.f7_pos<256)
				{
					if(ice_console.f7_pos<ice_console.f7_length)		
					{	
						for(i=254;i>=ice_console.f7_pos;i--)
						{
							if(_utf_code==0)ice_console.f7_line[i+1]=ice_console.f7_line[i];
							ice_console.f7_line2[i+1]=ice_console.f7_line2[i];
						}
					}
					if(_utf_code==0)ice_console.f7_line[ice_console.f7_pos]=0;
					ice_console.f7_line2[ice_console.f7_pos]=key;
					ice_console.f7_pos++;
					ice_console.f7_length++;
				}
			}
			_utf_code=0;
		
		}

		switch(key) {
				case 259: // left
					if(ice_console.f7_pos==0 && ice_console.f7_length==0) continue;
					if(ice_console.f7_pos>0)	ice_console.f7_pos--;
					if(ice_console.f7_pos<ice_console.f7_start) ice_console.f7_start=ice_console.f7_pos;
					break;
				case 260: // right
					if(ice_console.f7_pos==0 && ice_console.f7_length==0) continue;
					if(ice_console.f7_pos<256 && ice_console.f7_pos<ice_console.f7_length) 	ice_console.f7_pos++;
					break;
				case 272: // back space
					if(ice_console.f7_pos>0)
					{		
						for(i=1;i<256;i++)
						{
							if(i>=ice_console.f7_pos)
							{
								ice_console.f7_line[i-1]=ice_console.f7_line[i];
								ice_console.f7_line2[i-1]=ice_console.f7_line2[i];
							}
						}
						ice_console.f7_pos--;
						if(ice_console.f7_length>0)ice_console.f7_length--;
					}					
					break;
				case 263: // home
					if(ice_console.f7_pos==0 && ice_console.f7_length==0) continue;
					ice_console.f7_pos=ice_console.f7_start=0;
					break;
				case 264: // end
					if(ice_console.f7_pos==0 && ice_console.f7_length==0) continue;
					ice_console.f7_pos=ice_console.f7_length;
					break;
				case 275:		// del
					for(i=0;i<255;i++)
					{
						if(i>=ice_console.f7_pos)
						{
							ice_console.f7_line[i]=ice_console.f7_line[i+1];
							ice_console.f7_line2[i]=ice_console.f7_line2[i+1];
						}
					}
					if(ice_console.f7_length>0)
					{
						ice_console.f7_line[ice_console.f7_length]=ice_console.f7_line2[ice_console.f7_length]=0;
						ice_console.f7_length--;
					}
					break;
					break;
				case 13:		// Enter
					GetCommandBuffer();
					return TRUE ;
					break;
				case 27:		// esc
					return FALSE;
					break;
					break;
				default:
					break;
				case 9:   // tab
				case 257: // up
				case 258: // down
				case 261: // page up
				case 262: // page down
				case 274: // insert
				case 513:		// F1
				case 514:		// F2
				case 515:		// F3
				case 516:		// F4
				case 517:		// F5
				case 518:		// F6
				case 519:		// F7
				case 520:		// F8
				case 521:		// F9
				case 522:		// F10
				case 523:		// F11
				case 524:		// F12
					continue;
					break;
		
			}  // switch

		if(_utf_code==0)
		{
			if(ice_console.f7_pos>256) ice_console.f7_pos=256;
			if(ice_console.f7_pos<0) ice_console.f7_pos=0;
			if(ice_console.f7_pos>ice_console.f7_length)
			{
				ice_console.f7_length=ice_console.f7_pos;
			}
			draw_dialog_f7(ice_console.f7_pos,caption);
		}
	}

	return FALSE;
}



int dialog_comand_line(int key,bool _utf,bool is_terminal) 
{
	int i;
//	unsigned char  *p;
	int  _utf_code = 0;
	bool action = FALSE;


	if((key==208)||(key==209)) 	
	{
		if(ice_console.pos<ice_console.length)		
		{	
			for(i=510;i>=ice_console.pos;i--)
			{
				ice_console.main_line[i+1]=ice_console.main_line[i];
			}
		}
		ice_console.main_line[ice_console.pos]=key;
		return 1;	
	}

		switch(key) {
				case 259: // left
					if(ice_console.pos==0 && ice_console.length==0) return -1;
					if(ice_console.pos>0)	ice_console.pos--;
					if(ice_console.pos<ice_console.start) ice_console.start=ice_console.pos;
					action=TRUE;
					break;
				case 260: // right
					if(ice_console.pos==0 && ice_console.length==0) return -1;
					if(ice_console.pos<512) 	ice_console.pos++;
					action=TRUE;
					break;
				case 272: // back space
					if(ice_console.pos>0)
					{		
						for(i=1;i<512;i++)
						{
							if(i>=ice_console.pos)
							{
								ice_console.main_line[i-1]=ice_console.main_line[i];
								ice_console.main_line2[i-1]=ice_console.main_line2[i];
							}
						}
						ice_console.pos--;
						if(ice_console.length>0)ice_console.length--;
					}					
					break;
				case 263: // home
					if(ice_console.pos==0 && ice_console.length==0) return -1;
					ice_console.pos=ice_console.start=0;
					action=TRUE;
					break;
				case 264: // end
					if(ice_console.pos==0 && ice_console.length==0) return -1;
					ice_console.pos=ice_console.length;
					action=FALSE;
					break;
				case 275:		// del
					for(i=0;i<511;i++)
					{
						if(i>=ice_console.pos)
						{
							ice_console.main_line[i]=ice_console.main_line[i+1];
							ice_console.main_line2[i]=ice_console.main_line2[i+1];
						}
					}
					if(ice_console.length>0)
					{
						ice_console.main_line[ice_console.length]=ice_console.main_line2[ice_console.length]=0;
						ice_console.length--;
					}
					break;
				case 15:		// Enter
					if(is_terminal)	return -1 ;
					else return 2;
					break;
				case 13:		// Enter
					if(ice_console.pos==0 && ice_console.length==0) return -1;
					return 2 ;
					break;
				case 27:		// esc
					if(ice_console.pos==0 && ice_console.length==0) return -1;
					return 3;
					break;
				default:
					if(key==42)
						if(!is_terminal)
							if(ice_console.length==0)
								break;
					if(ice_console.pos<512)
					{
						if(ice_console.pos<ice_console.length)		
						{	
							for(i=510;i>=ice_console.pos;i--)
							{
								if(!_utf)ice_console.main_line[i+1]=ice_console.main_line[i];
								ice_console.main_line2[i+1]=ice_console.main_line2[i];
							}
						}
						if(!_utf)ice_console.main_line[ice_console.pos]=0;
						ice_console.main_line2[ice_console.pos]=key;
						_utf_code=0;
						ice_console.pos++;
						ice_console.length++;
					}
					break;
				case 9:   // tab
				case 257: // up
				case 258: // down
				case 261: // page up
				case 262: // page down
				case 274: // insert
				case 513:		// F1
				case 514:		// F2
				case 515:		// F3
				case 516:		// F4
				case 517:		// F5
				case 518:		// F6
				case 519:		// F7
				case 520:		// F8
				case 521:		// F9
				case 522:		// F10
				case 523:		// F11
				case 524:		// F12
					return -1;
					break;
		
			}  // switch

		if(_utf_code==0)
		{
			if(ice_console.pos>512) ice_console.pos=512;
			if(ice_console.pos<0)   ice_console.pos=0;
			draw_command_line(ice_console.pos);
		}

	return 1;
}








