#include <sys/types.h>
#include <signal.h>
#include <termios.h>
#include <unistd.h>
#include <curses.h>
#include <err.h>
#include "ice.h"
#include "dir.h"
#include <syslog.h>

static char bu [1024];
static char * _ext;


void ICE_KEY_ENTER(void)
{
			if (strcmp (cur->cat[cur->curfile].name, "..")==0) // наверх
			{
				int len = strlen(basename(cur->cwd));
				snprintf(cur_panel->DirUp,strlen(cur->cwd)-len+1,"/%s",cur->cwd);
				cur_panel->GoUp=TRUE;
				GoNewDir();
			}
			else if(IsDir())
			{
				if(strlen(cur->cwd)==1)
					sprintf(cur_panel->DirDown,"/%s",cur->cat[cur->curfile].name);
				else
					sprintf(cur_panel->DirDown,"%s/%s",cur->cwd,cur->cat[cur->curfile].name);
				sprintf(cur_panel->CurFileDown,"%s",cur->cat[cur->curfile].name);
				cur_panel->GoDown=TRUE;
				GoNewDir();
			}
			else // enter to archiv or exec	
			{
				sprintf(vfs_cur->file_ext,"%s",extension (cur->cat[cur->curfile].name));
				if ((strcmp (vfs_cur->file_ext,".zip")==0) || (strcmp (vfs_cur->file_ext , ".tgz")==0) || (strcmp (vfs_cur->file_ext , ".gz")==0)) 
				{
					ice_vfs_init(cur->cwd);
					vfs_cur->is_vfs=TRUE;
					sprintf(vfs_cur->file_name,"%s/%s",cur->cwd,cur->cat[cur->curfile].name);
					int result = 0 ;
					if (strcmp (vfs_cur->file_ext,".zip")==0)
					{
						int my_argc=3;
						char *my_argv[3]={"unzip","-l",vfs_cur->file_name};
					  result = ice_unzip(my_argc,  my_argv);
					} 
					else if ((strcmp (vfs_cur->file_ext,".tgz")==0) || (strcmp (vfs_cur->file_ext,".gz")==0))
					{
						vfs_cur->bad_format=FALSE;
						int my_argc=4;
						char *my_argv[4]={"libtar","-z","-t",vfs_cur->file_name};
						result = ice_tar(vfs_cur->file_name,"","","", 1);
					}
					if(result>=0)
					{
						vfs_get_subdir("/");
						cur = cur==&left ? &vfs_left : &vfs_right;
						vfs_setdir(cur, "/", vfs_cur->List_Subdir);
					}
				}
				else
				{
					if(cur->cat[cur->curfile].execable)
					{
						sprintf(bu,"%s/%s",cur->cwd,cur->cat[cur->curfile].name);	
						files_enter(bu);
						ice_init_console();
						draw_command_line(0); 
					}
				}	
			}

}

void ICE_KEY_ENTER_VFS(void)
{
		if (strcmp (cur->cat[cur->curfile].name, "..")==0) // наверх
		{
			vfs_cur->List_Subdir = NULL ;
			if(strlen(vfs_cur->Path_Dir)!=0)  // 
			{
				ice_vfs_path_Pop(&vfs_cur->Path);
				vfs_get_subdir(vfs_cur->Path_Dir); 
				vfs_setdir(cur, "/", vfs_cur->List_Subdir);
				if(cur->num==1)
				{
					vfs_cur->bad_format=TRUE;
					if ((strcmp (vfs_cur->file_ext , ".tgz")==0) || (strcmp (vfs_cur->file_ext , ".gz")==0)) 
					{
						ice_vfs_Post_Add_Tar(1,"");
						vfs_setdir(cur, "/", vfs_cur->List_Subdir);
					}
				}	
			}
			else  // выход из архива
			{
				vfs_cur->is_vfs=FALSE;
				cur = cur==&vfs_left ? &left : &right;
				setdir (cur, cur->cwd); 
			}
		}
		else if(IsDir())
		{
				vfs_cur->List_Subdir = NULL ;
				ice_vfs_path_Push(&vfs_cur->Path , cur->cat[cur->curfile].name);
				vfs_get_subdir(vfs_cur->Path_Dir); 
				vfs_setdir(cur, "/", vfs_cur->List_Subdir);
		}

}


void ICE_KEY_LEFT(void)
{
	if(cur_panel->list_type==0)
	{
			if (strcmp (cur->cat[cur->curfile].name, "..")==0) // наверх
			{
				int len = strlen(basename(cur->cwd));
				snprintf(cur_panel->DirUp,strlen(cur->cwd)-len+1,"/%s",cur->cwd);
				cur_panel->GoUp=TRUE;
			}
			else 
			{
				cur->curfile=0;	
				cur->topfile=0;
				InitBottomFiles();
			}
			GoNewDir();
	}

	if(cur_panel->list_type==1)
	{
		if(strcmp(cur->cat[cur->curfile].name,"..")==0) // наверх
		{
			int len = strlen(basename(cur->cwd));
			snprintf(cur_panel->DirUp,strlen(cur->cwd)-len+1,"/%s",cur->cwd);
			cur_panel->GoUp=TRUE;
			GoNewDir();
		}
		else
		{
			if((cur->curfile-height() > 0))
			{
				if(cur->curfile	-height()< cur->topfile)
				{
					cur->curfile -=height();
					cur->topfile -=height();
					cur->bottomfile -=height();
					if(cur->topfile<0) cur->topfile=0;	

				}
				else
				{
					cur->curfile -=height();
				}
			}
			else
			{
				cur->curfile	 =0;
				cur->topfile	 =0;
				cur->bottomfile  =2*height();;
			}
		}	
	}

}


void ICE_KEY_LEFT_VFS(void)
{

 	if (strcmp (cur->cat[cur->curfile].name, "..")==0) // наверх
	{
		vfs_cur->List_Subdir = NULL ;
		if(strcmp(vfs_cur->Path_Dir,"")!=0)
		{
			ice_vfs_path_Pop(&vfs_cur->Path);
			vfs_get_subdir(vfs_cur->Path_Dir); 
			vfs_setdir(cur, "/", vfs_cur->List_Subdir);
		}
		else // выход из архива
		{
			cur = cur==&vfs_left ? &left : &right;
			vfs_cur->is_vfs=FALSE;
			setdir (cur, cur->cwd); 
		}
	}
	else
	{
		cur->curfile=0;
	}
	GoNewDir();


}

void KEY_RIGHT_(void)
{
	if(vfs_cur->is_vfs) return;
	if(cur_panel->list_type==0)
	{
		if((ice_filetype(&cur->cat[cur->curfile],vfs_cur->is_vfs)=='/'))
		{
			if (strcmp (cur->cat[cur->curfile].name, "..")==0) // наверх
			{
				int len = strlen(basename(cur->cwd));
				snprintf(cur_panel->DirUp,strlen(cur->cwd)-len+1,"/%s",cur->cwd);
				cur_panel->GoUp=TRUE;
			}
			else // вниз
			{
				sprintf(cur_panel->CurFileDown,"%s",cur->cat[cur->curfile].name);
				sprintf(cur_panel->DirDown,"%s/%s",cur->cwd,cur->cat[cur->curfile].name);
				cur_panel->GoDown=TRUE;
			}

			GoNewDir();
		}
	}
	if(cur_panel->list_type==1)
	{
		if((cur->curfile+height() <= cur->num-1))
		{
			cur->curfile	+=height();
			if(cur->curfile	> cur->bottomfile-1)
			{
				cur->topfile +=height();
				cur->bottomfile +=height();
			}
		}
		else
		{
			cur->bottomfile  =cur->num;
			cur->curfile	 =cur->bottomfile-1;
			cur->topfile  	 =cur->bottomfile-2*height();
			if(cur->topfile<0) cur->topfile=0;
		}
	}

}


int vfs_filetype(char * name)
{
		char * s = name;
		s += strlen(name)-1;
		char end_char = *s;
		return end_char;
}

static char _f5_tar1[512];
static char * f5_tar1 = &_f5_tar1[0];
static char _f5_s[512];
static char * f5_s 	 = &_f5_s[0];


void KEY_VFS_F5(char * name)
{
  char _f5_source[512];
  char * f5_source=&_f5_source[0];
  char _f5_target[512];
  char * f5_target=&_f5_target[0];
	int result = 0 ;

			if(cur==&vfs_right)
			{
				if(mystrcmp(left.cwd,"/")==1) sprintf(f5_target,"/");
				else sprintf(f5_target,"%s",left.cwd);
			}
			if(cur==&vfs_left)
			{
				if(mystrcmp(right.cwd,"/")==1) sprintf(f5_target,"/");
				else sprintf(f5_target,"%s",right.cwd);
			}

			int vfs_type_file = vfs_filetype(name);
			f5_source = get_vfs_path_f5(vfs_cur->Path,name,vfs_type_file);
			
			if(vfs_type_file !='/') // file
			{
				if(strcmp(f5_source,name)!=0)
					sprintf(f5_source,"%s%s",f5_source,name);
				int result = 0 ;
				if (strcmp (vfs_cur->file_ext,".zip")==0) 
				{
					int my_argc=7;
					char *my_argv[7]={"unzip","-j",vfs_cur->file_name,f5_source,"-x","-d",f5_target};
					draw_dialog_waiting("Идет разархивирование zip ... ",f5_source);
					result = ice_unzip(my_argc,  my_argv);
				}
				else if ((strcmp (vfs_cur->file_ext,".tgz")==0) || (strcmp (vfs_cur->file_ext,".gz")==0)) 
				{
					char * _path = malloc(512);
					sprintf(_path,"./%s",f5_source);
					draw_dialog_waiting("Идет разархивирование tar ... ",f5_target);
					result = ice_tar(vfs_cur->file_name,f5_target,_path,name, 2);
				}
			}
			else	// dir
			{
				sprintf(f5_tar1,"%s%s",f5_source,name);
				sprintf(f5_s,"%s%s%s",f5_source,name,"*");
				char f5_tar[512];
				if(strlen(f5_target)==1) sprintf(f5_tar,"/%s",name);
				else sprintf(f5_tar,"%s/%s",f5_target,name);

				if (strcmp (vfs_cur->file_ext,".zip")==0) 
				{
					// pre-create pats
					vfs_get_subdir_f5(f5_tar1,name,f5_target); 
					int my_argc=7;
					char * ft = malloc(1024);
					struct vfs_path * current = vfs_cur->List_Dir_F5;
					while(current !=NULL)
					{
						sprintf(ft,"%s/%s",f5_target,current->name);
						int result = ice_mkdir (ft);
						current=current->next;
						if(current==vfs_cur->List_Dir_F5) break;
					}
	
					// copy files
					vfs_get_subdir_files_f5(f5_tar1,name,f5_target); 
					struct vfs_node_f5 * current2 = vfs_cur->List_F5;
					while(current2 !=NULL)
					{
						draw_dialog_waiting("Идет разархивирование zip ... ",current2->source);
						char *my_argv[7]={"unzip","-j",vfs_cur->file_name,current2->source,"-x","-d",current2->target};
						int result = ice_unzip(my_argc,  my_argv);
						current2=current2->next;
						if(current2==vfs_cur->List_F5) break;
					}
				}
				else if ((strcmp (vfs_cur->file_ext,".tgz")==0) ||(strcmp (vfs_cur->file_ext,".gz")==0))
				{
					vfs_get_subdir_f5(f5_tar1,name,f5_target); 
					vfs_get_subdir_files_f5(f5_tar1,name,f5_target); 
					char * _path = malloc(512);
					sprintf(_path,"./%s",f5_source);
					int result = ice_tar(vfs_cur->file_name,f5_target,_path,name, 3);
				}
			}
			if(result >=0)
			{
				if(cur==&vfs_left) 	setdir (&right, right.cwd);
				else 								setdir (&left, left.cwd);
			}
}

void KEY_F5(int type_copy,char * dest)
{
  bool result_F5 = TRUE;
  register struct file *p_file;
  char _f5_source[512];
  char * f5_source=&_f5_source[0];
  char _f5_target[512];
  char * f5_target=&_f5_target[0];
  int _old_topfile = 0 ;	
  int _old_curfile = 0 ;	

	if( (strcmp(left.cwd,right.cwd)==0 && !ice_vfs_left.is_vfs && !ice_vfs_right.is_vfs) || 
			(ice_vfs_left.is_vfs && ice_vfs_right.is_vfs) || 
			(cur_panel == &panel_left && ice_vfs_right.is_vfs && !ice_vfs_left.is_vfs) ||  
			(cur_panel == &panel_right && ice_vfs_left.is_vfs && !ice_vfs_right.is_vfs))
	{
		result_F5 = dialog_action("Копирование невозможно",3,FALSE,"","");
		getch();
		return;
	}

		if(vfs_cur->is_vfs) // vfs
		{
				result_F5 = dialog_action("Копирование",4,TRUE,"","");
				if(result_F5) 
				{
					if(GetCurrentTag()>0) // group 
					{
						for (p_file=cur->cat; p_file<cur->cat+cur->num; ++p_file)
						{
							if(p_file->tag)		KEY_VFS_F5(p_file->name);
						}
					}
					else
					{
						KEY_VFS_F5(cur->cat[cur->curfile].name);
					}
				}
		} 		//////////////////////// vfs end

		else if(type_copy==1) // F5 key - копирование обычных файлов
		{
			_old_topfile = cur->topfile ;	
			_old_curfile = cur->curfile ;	
			if(GetCurrentTag()>0) // copy group files
			{
				result_F5 = dialog_action("Копирование",4,TRUE,"выбранные файлы ",(cur==&left ? right.cwd : left.cwd));
				if(result_F5) 
				{
					for (p_file=cur->cat; p_file<cur->cat+cur->num; ++p_file)
					{
						if(p_file->tag)
						{
							if(mystrcmp(cur->cwd,"/")==1) sprintf(f5_source,"/%s",p_file->name);
							else sprintf(f5_source,"%s/%s",cur->cwd,p_file->name);
							if(cur==&right)
							{
								if(mystrcmp(left.cwd,"/")==1) sprintf(f5_target,"/%s",p_file->name);
								else sprintf(f5_target,"%s/%s",left.cwd,p_file->name);
							}
							if(cur==&left)
							{
								if(mystrcmp(right.cwd,"/")==1) sprintf(f5_target,"/%s",p_file->name);
								else sprintf(f5_target,"%s/%s",right.cwd,p_file->name);
							}
							if(strcmp(p_file->name,"..")!=0) 
							{
								draw_dialog_waiting("Идет копирование...",p_file->name);
								ice_cp(f5_source,f5_target);
							}
						}
					}
					setdir (&left, left.cwd);
					setdir (&right, right.cwd);
					cur->topfile = _old_topfile  ;	
					cur->curfile = _old_curfile  ;	
				}
			}
			else // copy single file
			{
				if(strcmp(cur->cat[cur->curfile].name,"..")==0) return;
				if(mystrcmp(cur->cwd,"/")==1) sprintf(f5_source,"/%s",cur->cat[cur->curfile].name);
				else sprintf(f5_source,"%s/%s",cur->cwd,cur->cat[cur->curfile].name);
				if(cur==&right)
				{
					if(mystrcmp(left.cwd,"/")==1) sprintf(f5_target,"/%s",cur->cat[cur->curfile].name);
					else sprintf(f5_target,"%s/%s",left.cwd,cur->cat[cur->curfile].name);
				}
				if(cur==&left)
				{
					if(mystrcmp(right.cwd,"/")==1) sprintf(f5_target,"/%s",cur->cat[cur->curfile].name);
					else sprintf(f5_target,"%s/%s",right.cwd,cur->cat[cur->curfile].name);
				}
				result_F5 = dialog_action("Копирование",4,TRUE,f5_source,f5_target);
				if(result_F5) 
				{
					draw_dialog_waiting("Идет копирование...",f5_source);
					ice_cp(f5_source,f5_target);
					setdir (&left, left.cwd);
					setdir (&right, right.cwd);
					cur->topfile = _old_topfile  ;	
					cur->curfile = _old_curfile  ;	
					if(cur->curfile > cur->num-1) cur->curfile = cur->num-1;
				}
			}
		}
		else // shift + F5 key 
		{
				if(strcmp(cur->cat[cur->curfile].name,"..")==0) return;
				if(mystrcmp(cur->cwd,"/")==1) sprintf(f5_source,"/%s",cur->cat[cur->curfile].name);
				else sprintf(f5_source,"%s/%s",cur->cwd,cur->cat[cur->curfile].name);
				ice_cp(f5_source,dest);
				setdir (&left, left.cwd);
				setdir (&right, right.cwd);
		}

}

void KEY_F6(int type_move,char * dest)
{
  bool result_F6 = TRUE;
  register struct file *p_file;
  char _f6_source[512];
  char * f6_source=&_f6_source[0];
  char _f6_target[512];
  char * f6_target=&_f6_target[0];
  int _old_topfile = 0 ;	
  int _old_curfile = 0 ;	

	if(type_move==1)
	{
		if(strcmp(left.cwd,right.cwd)==0)
		{
			result_F6 = dialog_action("Перемещение невозможно",3,FALSE,"","");
			return;
		}

		_old_topfile = cur->topfile ;	
		_old_curfile = cur->curfile ;	
		if(GetCurrentTag()>0) // move group files
		{
			result_F6 = dialog_action("Перемещение",4,TRUE,"выбранные файлы ",(cur==&left ? right.cwd : left.cwd));
			if(result_F6) 
			{
				for (p_file=cur->cat; p_file<cur->cat+cur->num; ++p_file)
				{
						if(p_file->tag)
						{
							if(mystrcmp(cur->cwd,"/")==1) sprintf(f6_source,"/%s",p_file->name);
							else sprintf(f6_source,"%s/%s",cur->cwd,p_file->name);
							if(cur==&right)
							{
								if(mystrcmp(left.cwd,"/")==1) sprintf(f6_target,"/%s",p_file->name);
								else sprintf(f6_target,"%s/%s",left.cwd,p_file->name);
							}
							else if(cur==&left)
							{
								if(mystrcmp(right.cwd,"/")==1) sprintf(f6_target,"/%s",p_file->name);
								else sprintf(f6_target,"%s/%s",right.cwd,p_file->name);
							}
							if(strcmp(p_file->name,"..")!=0)
							{
								draw_dialog_waiting("Идет перемещение...",p_file->name);
								ice_mv(f6_source,f6_target);
							}
						}	
				}
				setdir (&left, left.cwd);
				setdir (&right, right.cwd);
				cur->topfile = _old_topfile  ;	
				cur->curfile = _old_curfile  ;	
				if(cur->curfile > cur->num-1) cur->curfile = cur->num-1;
			}
		}
		else // move single file
		{
			if(strcmp(cur->cat[cur->curfile].name,"..")==0) return;
			if(mystrcmp(cur->cwd,"/")==1) sprintf(f6_source,"/%s",cur->cat[cur->curfile].name);
			else sprintf(f6_source,"%s/%s",cur->cwd,cur->cat[cur->curfile].name);
			if(cur==&right)
			{
				if(mystrcmp(left.cwd,"/")==1) sprintf(f6_target,"/%s",cur->cat[cur->curfile].name);
				else sprintf(f6_target,"%s/%s",left.cwd,cur->cat[cur->curfile].name);
			}
			if(cur==&left)
			{
				if(mystrcmp(right.cwd,"/")==1) sprintf(f6_target,"/%s",cur->cat[cur->curfile].name);
				else sprintf(f6_target,"%s/%s",right.cwd,cur->cat[cur->curfile].name);
			}
			result_F6 = dialog_action("Перемещение",4,TRUE,f6_source,f6_target);
			if(result_F6) 
			{	
				if(strcmp(cur->cat[cur->curfile].name,"..")!=0)
				{
						draw_dialog_waiting("Идет перемещение...",cur->cat[cur->curfile].name);
					    ice_mv(f6_source,f6_target);
						setdir (&left, left.cwd);
						setdir (&right, right.cwd);
						cur->topfile = _old_topfile  ;	
						cur->curfile = _old_curfile  ;	
						if(cur->curfile > cur->num-1) cur->curfile = cur->num-1;
				}
			}
		}
	}
	else
	{
		if(strcmp(cur->cat[cur->curfile].name,"..")==0) return;
		if(mystrcmp(cur->cwd,"/")==1) sprintf(f6_source,"/%s",cur->cat[cur->curfile].name);
		else sprintf(f6_source,"%s/%s",cur->cwd,cur->cat[cur->curfile].name);
		ice_mv(f6_source,dest);
		setdir (&left, left.cwd);
		setdir (&right, right.cwd);
	}

}

