#include <sys/types.h>
#include <signal.h>
#include <termios.h>
#include <unistd.h>
#include <curses.h>
#include <err.h>
#include "ice.h"
#include "dir.h"
#include "slang/slang.h"
#include <syslog.h>

#define endwin() SLsmg_reset_smg()

void Scrolling(int _screen)
{
	int i;
	struct file *cc=&cur->cat[0];
	for (i=0; i<cur->num; ++i, ++cc) 
	{
		if((mystrcmp(cc->name,cur_panel->CurFileDown)==1)&&(ice_filetype(cc,vfs_cur->is_vfs)=='/')&&(mystrcmp("",cur_panel->CurFileDown)==0)) 
		{
			cur->curfile=i;
			if(i>=cur->bottomfile)
			{
				cur->bottomfile=i+1;
				cur->topfile=cur->bottomfile-_screen*height();
				break;
			}
		}	
	}
}


void GoNewDir(void)
{
		int set_dir = 0 ;
		if(cur_panel->GoUp) // наверх
		{
			set_dir = setdir (cur, cur_panel->DirUp); 
		}
		else if(cur_panel->GoDown) // вниз
		{
			set_dir = setdir (cur, cur_panel->DirDown); 
		}
		if(set_dir==-1) return;
		cur->curfile=0;
		cur->topfile=0;
		cur->bottomfile=cur->num;

		if(cur_panel->list_type==0)
		{
			if(cur->num>height())
			{
				cur->bottomfile=height();
			}
			if(cur_panel->GoUp) Scrolling(1);
		}
		if(cur_panel->list_type==1)
		{
			if(cur->num>2*height())
			{
				cur->bottomfile=2*height();
			}
			if(cur_panel->GoUp) Scrolling(2);
		}
}



void InitBottomFiles()
{
	if(left.num > height()) left.bottomfile = height();
	else left.bottomfile   = left.num;
	right.bottomfile  = (height())*2;
	if(right.num < 2*height()) right.bottomfile = right.num;
}


int tagged (void)
{
	register int i, n;

	for (i=n=0; i<cur->num; ++i)
	{
		if(strcmp(cur->cwd,"/")==0)
		{
				if (cur->cat[i].tag)
					++n;
		}
		else
		{
			if(strcmp(cur->cat[i].name,"..")==1)
				if (cur->cat[i].tag)
				{
					++n;
				}
		}
	}	

	return (n);
}

int GetCurrentTag(void)
{
	int count = tagged();
	if(cur==&left)left_count_tag=count;
	else right_count_tag=count;
	return count ;
}

void tagall (void)
{
	register struct file *f;

	for (f=cur->cat; f<cur->cat+cur->num; ++f)
	{
			f->tag ^= 1;
	}
	counttag (cur);
}

void tag_sel_all (char *buf)
{
	register struct file *f;

	for (f=cur->cat; f<cur->cat+cur->num; ++f)
	{
		if ((f->mode & S_IFMT) == (unsigned) S_IFREG &&
		    (match2 (f->name, buf)))
			{
				f->tag = 1;
			}
	}
	counttag (cur);
}

void untagall (void)
{
	register struct file *f;
	for (f=cur->cat; f<cur->cat+cur->num; ++f)
			f->tag ^= 0;
	counttag (cur);
}




bool IsDir(void)
{
	bool _isdir=FALSE;
    if((ice_filetype(&cur->cat[cur->curfile],vfs_cur->is_vfs)=='/'))
		_isdir=TRUE;

	return _isdir;
}

void InitTags(void)
{

  char _f5_source[512];
  char _f5_target[512];
  char * f5_source=&_f5_source[0];
  char * f5_target=&_f5_target[0];

	
	int i,count=0;
    register struct file *p_file;
	for (p_file=cur->cat; p_file<cur->cat+cur->num; ++p_file)
	{
		if(p_file->tag)
		{
			if(strcmp(p_file->name,"..")==1)
			{
				DATA temp;
				temp.name = malloc(strlen(p_file->name) * sizeof(char));
				temp.name = strdup(p_file->name);
				TheArray = (DATA*)realloc(TheArray, (count * sizeof(DATA)));
				TheArray[count] = temp; 
				count++;
			}
		}
	}


	for (i=0; i<count; i++)
	{
		if(mystrcmp(cur->cwd,"/")==1) sprintf(f5_source,"/%s",TheArray[i].name);
		else sprintf(f5_source,"%s/%s",cur->cwd,TheArray[i].name);
		if(cur==&right)
		{
			if(mystrcmp(left.cwd,"/")==1) sprintf(f5_target,"/%s",TheArray[i].name);
			else sprintf(f5_target,"%s/%s",left.cwd,TheArray[i].name);
		}
		if(cur==&left)
		{
			if(mystrcmp(right.cwd,"/")==1) sprintf(f5_target,"/%s",TheArray[i].name);
			else sprintf(f5_target,"%s/%s",right.cwd,TheArray[i].name);
		}
		ice_cp(f5_source,f5_target);
		ice_rm(f5_source);
	}


}

void ChangePanel(void)
{

	cur_panel  = cur_panel == &panel_left ? &panel_right : &panel_left;
	vfs_cur = vfs_cur==&ice_vfs_left ? &ice_vfs_right : &ice_vfs_left;

	if(cur == &left || cur == &vfs_left) cur = ice_vfs_right.is_vfs ? &vfs_right : &right;
	else if (cur == &right || cur == &vfs_right) cur = ice_vfs_left.is_vfs ? &vfs_left : &left;


	chdir (cur->cwd);
	

}

void key_manage(int key)
{
  char namebuf [50];
  char __dir_name[512];
  char buff [512];
  char mkdir_buff[512];

  char *name ;
  bool delete_file=FALSE;
  char *_dir_name;
  register struct file *p_file;
  char * dialog_result;
  _dir_name=&__dir_name[0];
  bool result_F7 = FALSE;
  bool result_F = TRUE;
  int _old_topfile = 0 ;	
  int _old_curfile = 0 ;	
  int old_list_type	= 0 ;

	cur_panel->GoUp=FALSE;
	cur_panel->GoDown=FALSE;
	delete_file=FALSE;



switch( key )
{
case 42 : // *
			if(ice_console.length>0) break;
			tagall();
			break;
case 43 : // +
		sprintf(ice_console.f7_buf,"%s","*");
		result_F7 = dialog_action_f7("Выбор файлов");
		if(result_F7)
		{	
			dialog_result = &ice_console.f7_buf[0];
			sprintf(buff,"%s",dialog_result);	
			strncpy(mkdir_buff, buff,strlen(buff));
			mkdir_buff[strlen(buff)]='\0';
			tag_sel_all(mkdir_buff);
		}
		break;
case  258: // KEY_DOWN 
		if(cur_panel->list_type==0)		
		{
			if(cur->curfile < cur->num-1)
			{
				if (cur->curfile == cur->topfile+height()-1 && cur->topfile+height()-1 <= cur->num-1) 
				{
					cur->topfile ++;	
					cur->curfile ++;
					cur->bottomfile++;	
				}	
				else cur->curfile++;
			}
		}
		if(cur_panel->list_type==1)		
		{
			if(cur->curfile < cur->num-1)
			{
				if (cur->curfile == cur->topfile+2*height()-1 && cur->topfile+2*height()-1 <= cur->num-1) 
				{
					cur->topfile ++;	
					cur->curfile ++;
					cur->bottomfile++;	
				}	
				else cur->curfile++;
			}
		}
		break;
case 257  : // KEY_UP   
		if(cur_panel->list_type==0)		
		{
				if(cur->curfile>0)
				{
					if(cur->curfile>cur->topfile)	--cur->curfile;
					else
					{
						--cur->curfile;
						--cur->topfile;
						--cur->bottomfile;	
					}	
				}
		}
		if(cur_panel->list_type==1)		
		{
				if(cur->curfile>0)
				{
					if(cur->curfile==cur->topfile)
					{
						--cur->curfile;
						--cur->topfile;
						--cur->bottomfile;
					}
					else	--cur->curfile;
					}
			}

					break;
case 263 : // KEY_HOME 
				cur->curfile=0;
				cur->topfile=0;
				if(cur_panel->list_type==0)	 cur->bottomfile   = height();
				if(cur_panel->list_type==1)	 cur->bottomfile  = (height())*2;
				break;
case 264: // KEY_END  
				cur->curfile=cur->num-1;
				if(cur_panel->list_type==1)
				{
					if(cur->num>=2*height()) 
					{
						cur->topfile = cur->num - 2*height();
					}
					cur->bottomfile  = cur->num;
				}
				if(cur_panel->list_type==0)
				{
					cur->topfile = cur->num - height();
					cur->bottomfile  = cur->num;
				}
				if (cur->topfile < 0) cur->topfile = 0;
			break;
case 9: // '\t' TAB :
			ChangePanel();
		break;
case 262:		// page down
			if(cur_panel->list_type==0)
			{
				if((cur->curfile+height())<cur->num)
				{
					cur->curfile	+=height();
					cur->topfile	+=height();
					cur->bottomfile +=height();
				}
				else	
				{
					cur->curfile	= cur->num-1;
					cur->bottomfile =  cur->num;
					cur->topfile	=  cur->num- height();
				}
			}
			if(cur_panel->list_type==1)
			{
				if((cur->curfile+2*height())<cur->num)
				{
					cur->curfile	+=2*height();
					cur->topfile	+=2*height();
					cur->bottomfile +=2*height();
				}
				else	
				{
					cur->curfile	= cur->num-1;
					cur->bottomfile =  cur->num;
					cur->topfile	=  cur->num- 2*height();
					
				}
				if((cur->bottomfile-cur->topfile)<2*height())
				{
						cur->bottomfile=cur->num;
						cur->topfile=cur->num-2*height();
						cur->curfile=cur->num-1;
				}
			}
			if(cur->topfile<0)cur->topfile=0;
				break;
case 261:		// page up
			if(cur_panel->list_type==0)
			{
				if(((cur->curfile-height())>=0) &&((cur->topfile-height())>=0))
				{
					cur->curfile	-=height();
					cur->topfile	-=height();
					cur->bottomfile -=height();
				}
				else
				{
					cur->curfile	 =0;
					cur->topfile	 =0;
					cur->bottomfile  =height();
				}
			}
			if(cur_panel->list_type==1)
			{
				if((cur->curfile-2*height() >= 0) && (cur->topfile-2*height() >= 0))
				{
					cur->curfile	-=2*height();
					cur->topfile	-=2*height();
					cur->bottomfile -=2*height();
				}
				else
				{
					cur->curfile	 =0;
					cur->topfile	 =0;
					cur->bottomfile  =2*height();
					if(cur->num < 2*height()) cur->bottomfile = cur->num;
				}
			}
			if(cur->curfile<0) cur->curfile=0;
			if(cur->topfile<0) cur->topfile=0;
			if(cur->bottomfile<0) cur->bottomfile=0;
				break;
case 259 :  
				if(vfs_cur->is_vfs) ICE_KEY_LEFT_VFS();
				else ICE_KEY_LEFT();
				break;
case 260 :   
				KEY_RIGHT_();
				break;
case 13 :      // enter
				if(vfs_cur->is_vfs) ICE_KEY_ENTER_VFS();
				else ICE_KEY_ENTER();
		break;
case 15 :       // ctrl_o
		files_enter("");
		ice_init_console();
		draw_command_line(0); 
		break;
case 513: 		// F1 :      
		result_F = dialog_action("Help",5,FALSE,"","");
		break;
case 514: 		// F2 :      
		result_F = dialog_action("F2",6,FALSE,"","");
		break;
case 515: 		// F3 :      
		if((ice_filetype(&cur->cat[cur->curfile],vfs_cur->is_vfs)!='/'))
		{
			name = cur->cat[cur->curfile].name;
			strcpy (namebuf, name);
			editfile(namebuf,TRUE);
		}
		break;
case 516: 		// F4 :      
		if((ice_filetype(&cur->cat[cur->curfile],vfs_cur->is_vfs)!='/'))
		{
			name = cur->cat[cur->curfile].name;
			strcpy (namebuf, name);
			editfile(namebuf,FALSE);
		}
		break;
case -444: 		// shift + F7 :      
		sprintf(ice_console.f7_buf,"%s","");
		result_F7 = dialog_action_f7("Создать файл");
		if(result_F7)
		{	
			dialog_result = &ice_console.f7_buf[0];
			sprintf(buff,"%s/%s",cur->cwd,dialog_result);	
			strncpy(mkdir_buff, buff,strlen(buff));
			mkdir_buff[strlen(buff)]='\0';
			int result = ice_create_file (mkdir_buff);
			if(result>=0)
			{
				cur->curfile=0;
				cur->topfile=0;
				cur->bottomfile++;
				setdir (&left, left.cwd);
				setdir (&right, right.cwd);
			}
		}
		break;
case -445: 		// shift + F5 :      
		sprintf(ice_console.f7_buf,"%s",cur->cat[cur->curfile].name);
		result_F7 = dialog_action_f7("Копировать");
		if(result_F7)
		{	
			dialog_result = &ice_console.f7_buf[0];
			sprintf(buff,"%s/%s",cur->cwd,dialog_result);	
			strncpy(mkdir_buff, buff,strlen(buff));
			mkdir_buff[strlen(buff)]='\0';
			KEY_F5(2,mkdir_buff);
		}
		break;
case -446: 		// shift + F6 :      
		sprintf(ice_console.f7_buf,"%s",cur->cat[cur->curfile].name);
		result_F7 = dialog_action_f7("Переименовать");
		if(result_F7)
		{	
			dialog_result = &ice_console.f7_buf[0];
			sprintf(buff,"%s/%s",cur->cwd,dialog_result);	
			strncpy(mkdir_buff, buff,strlen(buff));
			mkdir_buff[strlen(buff)]='\0';
			KEY_F6(2,mkdir_buff);
		}
		break;
case 517: 		// F5 :      
			KEY_F5(1,"");
		break;
case 518: 		// F6 :      
			KEY_F6(1,"");
		break;
case 519 :      // F7 :  
		sprintf(ice_console.f7_buf,"%s","");
		result_F7 = dialog_action_f7("Создание каталога");
		if(result_F7)
		{	
			dialog_result = &ice_console.f7_buf[0];
			sprintf(buff,"%s/%s",cur->cwd,dialog_result);	
			strncpy(mkdir_buff, buff,strlen(buff));
			mkdir_buff[strlen(buff)]='\0';
			int result = ice_mkdir (mkdir_buff);
			if(result >= 0)
			{
				cur->curfile=0;
				cur->topfile=0;
				cur->bottomfile++;
				setdir (&left, left.cwd);
				setdir (&right, right.cwd);
			}
		}
	break;
	case 275 :      // del :      
	case 520 :      // F8 :      
		if ((strcmp (cur->cat[cur->curfile].name, "..")==0) && (GetCurrentTag()==0)) return;
		if(GetCurrentTag()>0) delete_file = dialog_action(" выбранные файлы ",1,TRUE,"","");
		else delete_file = dialog_action(cur->cat[cur->curfile].name,1,TRUE,"","");

		if(delete_file)	
		{
			_old_topfile = cur->topfile ;	
			_old_curfile = cur->curfile ;	
			if(GetCurrentTag()>0) // delete group files
			{
				for (p_file=cur->cat; p_file<cur->cat+cur->num; ++p_file)
				{
					if(p_file->tag)
					{
						if(strcmp(p_file->name,"..")!=0)
						{
								draw_dialog_waiting("Идет удаление...",cur->cat[cur->curfile].name);
								sprintf(_dir_name , "%s/%s",cur->cwd,p_file->name);
								ice_rm(_dir_name);
						}
					}
				}
			}
			else    // delete single file
			{
				if((ice_filetype(&cur->cat[cur->curfile],vfs_cur->is_vfs)=='/')) // delete dir 
				{
						draw_dialog_waiting("Идет удаление...",cur->cat[cur->curfile].name);
						sprintf(_dir_name , "%s/%s",cur->cwd,cur->cat[cur->curfile].name);
						ice_rm(_dir_name);
				} 
				else   // delete 1 regular file
				{
						draw_dialog_waiting("Идет удаление...",cur->cat[cur->curfile].name);
						sprintf(_dir_name , "%s/%s",cur->cwd,cur->cat[cur->curfile].name);
						if (unlink (_dir_name) < 0) {};
				}
			}
			setdir (&left, left.cwd);
			setdir (&right, right.cwd);
			cur->topfile = _old_topfile  ;	
			cur->curfile = _old_curfile  ;	
			if(cur->curfile > cur->num-1) cur->curfile = cur->num-1;
		}
		break;
	case 521 :      // F9 :      
		old_list_type=cur_panel->list_type;
		result_F = dialog_action("F9",7,FALSE,"","");
		if(old_list_type!=cur_panel->list_type)
		{

		}
		break;
	case 522 :      // F10 :      
		close_history();
		unset_interactive_mode();
		tty_reset();
		exit(0);
		break;
	case 274 :      // Insert :      
	cur->cat[cur->curfile].tag ^= 1;
	int _height=0;
	if(cur_panel->list_type==0)	_height=height();
	if(cur_panel->list_type==1) _height=2*height();
	if (cur->curfile < cur->num-1)	
	{
			cur->curfile++;
			if (cur->curfile >= _height )   
			{
				if((cur->topfile + _height) < cur->num	)
				{
					cur->topfile ++;	
					cur->bottomfile++;	
				}
			}
	}
	counttag (cur);
		break;
case 27 :   // ESC   
		break;
default:
		break; 

}	// switch


}


void ice_manage()
{
	
 	left_count_tag=0;
	right_count_tag=0;
	DisplayPanels();
	int get_key;
	bool _utf = FALSE;
  char bu [1024];
	char * cmdline_str_result22;
	int result = 0 ;
	bool IsTerminal=FALSE;

	while(TRUE)
	{
		result = 0 ;
		get_key = ice_key_code ();

		if(get_key>0 && get_key!=43)  // + block
			result =  dialog_comand_line(get_key,_utf,IsTerminal) ;
		if((get_key==208)||(get_key==209)) _utf=TRUE;
		else _utf=FALSE;		

		if(result>1)
		{
			switch(result)
			{
				case 2:  // enter
					if(get_key<0) continue;
					IsTerminal=TRUE;
					cmdline_str_result22 = &ice_console.main_buf[ice_console.start];
					sprintf(bu,"%s",cmdline_str_result22);	
					files_enter(bu);
					break;	
				case 3:  // esc
					break;	
			}
			ice_init_console();
			draw_command_line(0); 
		}
		else  
		{
			if(IsTerminal)
			{
				if(get_key==13 || get_key==15 )
				{
					IsTerminal=FALSE;
					GetCurrentTag();
  					DisplayPanels();
				}
			}
			else 
			{
				key_manage(get_key);
			  GetCurrentTag();
 			  DisplayPanels();
			}
		}

	}


}
