#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>

#include "slang/slang.h"

#include "ice.h"
#include "dir.h"

void UpdateColor()
{
	switch(color_scheme.type)
	{
		case 1: 
			color_scheme.type=2;
			color_scheme.background_editor_color=2;	
			sprintf(color_scheme.ice_color,"%s","black");	
			color_scheme.tag_color=2;
			color_scheme.file_color=1;
			color_scheme.file2_color=1;
		break;
		case 2: 
			color_scheme.type=1;
			color_scheme.background_editor_color=1;	
			sprintf(color_scheme.ice_color,"%s","blue");	
			color_scheme.tag_color=31;
			color_scheme.file_color=28;
			color_scheme.file2_color=32;
		break;
	}
}

void drawrightcursor(int y,int x , char * name,char *_filetype,unsigned tag,struct file *c,struct dir *d)
{
	int cols = SLtt_Screen_Cols  ;
    int row  = SLtt_Screen_Rows;

	if(tag) SLsmg_set_color (45);
	else 	SLsmg_set_color (44);

	SLsmg_gotorc (y,x);
	SLsmg_write_nstring (" ", cols/4-3);

	SLsmg_gotorc (y,x+1);
	SLsmg_write_nstring (name, cols/4-3);
	SLsmg_gotorc (y,x);
	SLsmg_write_string (_filetype);
  	SLsmg_gotorc (row-2,-1);

	if(d==&right)
	{
		SLsmg_set_color (0);
		SLsmg_gotorc (row-4,cols/2+2);
		SLsmg_write_nstring ((char *)c,cols/2-20);
		SLsmg_gotorc (row-4,cols-17);
		SLsmg_write_nstring ((char *)filesize(c), 15);
	}
	else
	{
		SLsmg_set_color (0);
		SLsmg_gotorc (row-4,2);
		SLsmg_write_nstring ((char *)c,cols/2-20);
		SLsmg_gotorc (row-4,cols/2-17);
		SLsmg_write_nstring ((char *)filesize(c), 15);
	}


}


void drawleftcursor(int y,int x , char * name,char * _filetype,unsigned tag,struct file *c,struct dir *d,bool is_vfs)
{
	int cols = SLtt_Screen_Cols  ;
  int row  = SLtt_Screen_Rows;
	if(tag) SLsmg_set_color (45);
	else 	SLsmg_set_color (44);

	SLsmg_gotorc (y,x+cols/2-22);
	SLsmg_write_nstring (" ", 20);

	SLsmg_gotorc (y,x+1);
	SLsmg_write_string (_filetype);

	SLsmg_gotorc (y,x+2);
	SLsmg_write_nstring (name, cols/2-33);

	SLsmg_gotorc (y,x+cols/2-30);
	SLsmg_write_nstring (" ", 7);

	if(ice_filetype(c,is_vfs)!='/' && 	(strcmp(name,"..")!=0))
	{
		SLsmg_gotorc (y,x+cols/2-30);
		SLsmg_write_nstring ((char *)filesize2(c), 7);
   		SLsmg_gotorc (y,x+cols/2-22);
		SLsmg_write_nstring((char *)timestr (c->mtime),20);
	}


	if(d==&left)
	{
		SLsmg_set_color (0);
		SLsmg_gotorc (row-4,x+2);
		SLsmg_write_nstring ((char *)c,cols/2-20);
		SLsmg_gotorc (row-4,x+cols/2-25);
		SLsmg_write_nstring ((char *)filesize(c), 15);
	}
	else
	{
		SLsmg_set_color (0);
		SLsmg_gotorc (row-4,cols/2+2);
		SLsmg_write_nstring ((char *)c,cols/2-20);
		SLsmg_gotorc (row-4,cols-17);
		SLsmg_write_nstring ((char *)filesize(c), 15);
	}
}

void drawleftpanel (int col, struct file *c, int n, struct dir *d,bool is_vfs)
{
	register int i;
	int _cur_index=-1;
	char *cur_file="";
	struct file *cc=c;
	char *_filetype=" ";
	char *cur_filetype=" ";
	unsigned cur_tag = 0;
	int index = 0;
	int cols = SLtt_Screen_Cols  ;
	int rows = SLtt_Screen_Rows  ;
	int inc=0;

	SLsmg_set_color (color_scheme.file_color); 

	if(d==&right || d==&vfs_right) 
	{
		inc = cols/2-1;
		SLsmg_draw_box (1, cols/2-1, rows-5, cols/2+1 );
		SLsmg_draw_box (1, cols/2-1, rows-5, cols/2-22 );
		SLsmg_draw_box (1, cols/2-1, rows-5, cols/2-30 );
		SLsmg_draw_box (1, cols/2-1, rows-3, cols/2+1 );
	}
	else
	{
		SLsmg_draw_box (1,0, rows-5, cols/2-1 );
		SLsmg_draw_box (1,0, rows-5, cols/2-22 );
		SLsmg_draw_box (1,0, rows-5, cols/2-30 );
		SLsmg_draw_box (1,0, rows-3, cols/2-1 );
	}


	for (i=0; i<n; ++i, ++c) 
	{

		_filetype=" ";
		index=i+d->topfile;
    if(ice_filetype(c,is_vfs)=='/')
		{
		    if(c->link) _filetype="~";
				SLsmg_set_color (0);
		    if(index==d->curfile)	
				if(cur==d)
				{
					cc=c;
					_cur_index=i+2;
					cur_file=c->name;
					if(c->tag) cur_tag = 1;
				}
		}
		else
		{
			if(ice_filetype(c,is_vfs)=='$')_filetype="-";
			else if(ice_filetype(c,is_vfs)=='~')_filetype="!";
		    else if(c->link) _filetype="@";
			else if(c->execable) _filetype="*";
			SLsmg_set_color (color_scheme.file_color);  
		    if(index==d->curfile)	
				if(cur==d)
				{
					cc=c;
					_cur_index=i+2;
					cur_file=c->name;
					cur_filetype=_filetype;
					if(c->tag) cur_tag = 1;
				}
		}

		if(cur_panel->GoUp) // return from dir
		{
			if((mystrcmp(c->name,cur_panel->CurFileDown)==1)&&(ice_filetype(c,is_vfs)=='/')&&(mystrcmp("",cur_panel->CurFileDown)==0)&&(strlen(c->name) == strlen(cur_panel->CurFileDown))) 
			{
				if(cur==d)
				{
					cc=c;
					_cur_index=i+2;
					cur_file=c->name;
					cur_filetype=_filetype;
					if(c->tag) cur_tag = 1;
					d->curfile=index;
					if(d->curfile>d->bottomfile)
					{
						d->bottomfile=d->curfile;
						d->topfile=d->bottomfile-height();
					}
				}
			}
		}

		if(c->tag) SLsmg_set_color (color_scheme.tag_color); 
    	SLsmg_gotorc (i+2,2+inc);
		SLsmg_write_nstring (c->name, cols/2-33);



		if(ice_filetype(c,is_vfs)!='/' && (strcmp(c->name,"..")!=0)) // filesize + datetime
		{
			SLsmg_set_color (color_scheme.file_color); 
		
			SLsmg_gotorc (i+2,inc+cols/2-30);
			SLsmg_write_nstring ((char *)filesize2(c), 7);
   		
			SLsmg_gotorc (i+2,inc+cols/2-22);
			SLsmg_write_nstring((char *)timestr (c->mtime),20);
		}

	
		SLsmg_set_color (color_scheme.file2_color); 
		SLsmg_gotorc (i+2,inc+1);
		SLsmg_write_string(_filetype);

		if(i>=(height()-1)) break;
		if(d->topfile+i > d->num-2) break;

	}

	if(_cur_index>0 && cur==d)
	{
		drawleftcursor(_cur_index, inc,cur_file,cur_filetype,cur_tag,cc,d,is_vfs);
	}

   	SLsmg_gotorc (1,inc+cols/2-30);
	SLsmg_write_nstring ("Размер",6);

   	SLsmg_gotorc (1,inc+cols/2-20);
	SLsmg_write_nstring ("Время",5);


}


// 2 cycle: draw left and then right column
// Erase, find and draw a cursor

void drawrightpanel (int col, struct file *c, int n, struct dir *d,bool is_vfs)
{

	register int i;
	int _cur_index=-1;
	char *cur_file="";
	char *_filetype=" ";
	char *cur_filetype=" ";
	struct file *cc=c;
	unsigned cur_tag = 0;
	int _cursor_x = -1;
	int _cursor_y=-1;
	int _cursor_y1=-1;
	int _cursor_y2=-1;
	int inc = 0 ;

	int cols = SLtt_Screen_Cols  ;
	int rows = SLtt_Screen_Rows  ;

	SLsmg_set_color (color_scheme.file_color); 

	if(d==&right || d==&vfs_right)
	{
		inc = cols/2-1;
		SLsmg_draw_box (1, cols/2-1, rows-5, cols/2+1 );   // внещний малый
		SLsmg_draw_box (1, 3*cols/4-1, rows-5, cols/2+1 ); // правый верхний
		SLsmg_draw_box (1, cols/2-1, rows-3, cols/2+1 );   // внешний большой
	}
	else
	{
		SLsmg_draw_box (1, 0, 		 rows-5, cols/2-1 );   // внещний малый
		SLsmg_draw_box (1, cols/4-1, rows-5, cols/4 ); // правый верхний
		SLsmg_draw_box (1, 0, 		 rows-3, cols/2-1 );   // внешний большой
	}

	int index=0;
	for (i=0; i<n; ++i, ++c)  // left column
	{
		_filetype=" ";
		index=i+d->topfile;
	    if(ice_filetype(c,is_vfs)=='/')  
		{
  	      if(c->link) _filetype="~";
			SLsmg_set_color (0);
		    if(index==d->curfile)	
				if(cur==d) 
				{
					cc=c;
					_cur_index=i+2;
					_cursor_y1=i+2;
					if(c->tag) cur_tag = 1;
					cur_file=c->name;
				}
		}
		else 
		{
		    if(c->link) _filetype="@";
			if(c->execable)  _filetype="*";
			SLsmg_set_color (color_scheme.file_color); 
		    if(index==d->curfile)	
				if(cur==d)
				{
					cc=c;
					_cur_index=i+2;
					_cursor_y1=i+2;
					if(c->tag) cur_tag = 1;
					cur_file=c->name;
					cur_filetype=_filetype;
				}
		}
		if(panel_right.GoUp) // return from dir
		{
			if((mystrcmp(c->name,cur_panel->CurFileDown)==1)&&(ice_filetype(c,is_vfs)=='/')&&(mystrcmp("",cur_panel->CurFileDown)==0)&&(strlen(c->name) == strlen(cur_panel->CurFileDown))) 
			{
					if(cur==d)
					{
						cc=c;
						_cur_index=i+2;
						_cursor_y1=i+2;
						if(c->tag) cur_tag = 1;
						cur_file=c->name;
						d->curfile=index;
					}
			}
		}

		if(c->tag) SLsmg_set_color (color_scheme.tag_color); 

    	SLsmg_gotorc (i+2, inc+2);
		SLsmg_write_nstring (c->name, cols/4-3);

		SLsmg_set_color (color_scheme.file2_color);	
		SLsmg_gotorc (i+2, inc+1);
		SLsmg_write_string(_filetype);


		if(i>=(height()-1)) break;
	}


	cur_filetype=" ";
	_cur_index=-1; 
	int ii = 0 ;
	index=height();
	c++;


	for (i=height(); i<n+height(); ++i, ++c) // right column
	{

		_filetype=" ";
		if(index>d->num-1) 
		{
			break; 
		}
		index=i+d->topfile;
	    if(ice_filetype(c,is_vfs)=='/')
		{
		  	if(c->link) _filetype="~";
			SLsmg_set_color (0);
		    if(index==d->curfile)	
			    if(cur==d) 
				{
					cc=c;
					_cur_index=ii+2;
					_cursor_y2=ii+2;
					if(c->tag) cur_tag = 1;
					cur_file=c->name;
				}
		}
		else
		{
		    if(c->link) _filetype="@";
			if(c->execable)  _filetype="*";
			SLsmg_set_color (color_scheme.file_color);  
		    if(index==d->curfile)	
			    if(cur==d)
				{
					cc=c;
					_cur_index=ii+2;
					_cursor_y2=ii+2;
					if(c->tag) cur_tag = 1;
					cur_file=c->name;
					cur_filetype=_filetype;
				}
		}
		
		if(cur_panel->GoUp) // return from dir
		{	
			if((mystrcmp(c->name,cur_panel->DirUp)==1)&&(ice_filetype(c,is_vfs)=='/')&&(mystrcmp("",panel_right.DirUp)==0)&&(strlen(c->name) == strlen(cur_panel->DirUp))) 
			{
				if(cur==d)
				{
					cc=c;
					_cur_index=ii+2;
					_cursor_y2=ii+2;
					if(c->tag) cur_tag = 1;
					cur_file=c->name;
					cur_filetype=_filetype;
					d->curfile=index;
				}
			}
		}


		if(d==&right || d==&vfs_right)
		{
			if(d->num>height())
			{
				if(index>d->num-1) break; 
	
				if(c->tag) SLsmg_set_color (color_scheme.tag_color);  
				SLsmg_gotorc (ii+2, 3*cols/4+1);
				SLsmg_write_nstring (c->name, cols/4-3);
		
				SLsmg_set_color (color_scheme.file2_color);	
				SLsmg_gotorc (ii+2, 3*cols/4);
				SLsmg_write_string(_filetype);
	
			}
		}
		else
		{
			if(d->num>height())
			{
				if(index>d->num-1) break; 
	
				if(c->tag) SLsmg_set_color (color_scheme.tag_color);  
				int _x = cols/4+2;
	//			if(d==&left && cur_panel->list_type==1) _x --;
				_x --;				
				SLsmg_gotorc (ii+2, _x);
				SLsmg_write_nstring (c->name, cols/4-3);
		
				SLsmg_set_color (color_scheme.file2_color);	
				_x = cols/4+1;
		//		if(d==&left && cur_panel->list_type==1) _x --;		
 				_x --;
				SLsmg_gotorc (ii+2, _x);
				SLsmg_write_string(_filetype);
	
			}
		}
		ii++;
		if(ii>=height()) break;
	
	} // for

	if(d==&right || d==&vfs_right)
	{
		if(d->curfile >= d->topfile+height()) // right column
		{
			_cursor_x = 3*cols/4;
			_cursor_y = _cursor_y2;
		}
		else // left column
		{
			_cursor_x = cols/2;
			_cursor_y = _cursor_y1;
		}
	
		if(cur_panel->GoDown)
		{
			_cursor_y=2;
			_cursor_x = cols/2;
		}
		if(d==cur)
			drawrightcursor(_cursor_y, _cursor_x,cur_file,cur_filetype,cur_tag,cc,d);
	}
	else
	{
		if(d->curfile >= d->topfile+height()) // right column
		{
			_cursor_x =  cols/4+1;
			_cursor_y = _cursor_y2;
			_cursor_x --;		
		}
		else // left column
		{
			_cursor_x = inc+1;
			_cursor_y = _cursor_y1;
		}
	
		if(cur_panel->list_type==1)
		{
			if(cur_panel->GoDown)
			{
				_cursor_y=2;
				_cursor_x = inc+1;
			}
			if(d==cur)
				drawrightcursor(_cursor_y, _cursor_x,cur_file,cur_filetype,cur_tag,cc,d);
		}
	}

}


void draw_dialog_warning(char * caption) 
{
  int  row, col;
 	row = SLtt_Screen_Rows;
 	col = SLtt_Screen_Cols;

	SLsmg_set_color (7);

	int y1 = row/2-3;
	int x1 = col/4; 
	int y2 = 5; 
	int x2 = col/2; 

    SLsmg_gotorc (row/2-3,col/4);
    SLsmg_set_char_set (1);
	SLsmg_fill_region (y1,x1,y2-1,x2, '_');
    SLsmg_set_char_set (0);
	SLsmg_draw_box (y1,x1,y2,x2);

    SLsmg_gotorc (row/2-1,col/4+12);
	SLsmg_write_string (caption);

	SLsmg_gotorc (row-2,-1);
    SLsmg_refresh ();

}

void draw_dialog_f1(char * caption) 
{
  	char _line [512];
    int  row, col;
		row = SLtt_Screen_Rows;
   	col = SLtt_Screen_Cols;

	SLsmg_set_color (51);

	int y1 = row/2-3;
	int x1 = col/4; 
	int y2 = 7; 
	int x2 = col/2+10; 

    SLsmg_gotorc (row/2-3,col/4);
    SLsmg_set_char_set (1);
	SLsmg_fill_region (y1,x1,y2-1,x2, '_');
    SLsmg_set_char_set (0);
	SLsmg_draw_box (y1,x1,y2,x2);

    SLsmg_gotorc (row/2-3,col/2-2);
    SLsmg_write_string (" Help ");


	sprintf(_line,"GNU ICE - свободно распространяемый консольный файловый менеджер.");
    SLsmg_gotorc (row/2-1,col/4+2);
    SLsmg_write_nstring (_line, col/2+5);

	sprintf(_line,"Он опубликован под лицензией GNU General Public License.");
		
    SLsmg_gotorc (row/2,col/4+2);
    SLsmg_write_nstring (_line, col/2+5);

	SLsmg_gotorc (row-2,-1);
    SLsmg_refresh ();
}


void draw_dialog_f2(char * caption) 
{
 	char _line [512];
  int  row, col;
	row = SLtt_Screen_Rows;
 	col = SLtt_Screen_Cols;

	SLsmg_set_color (51);

	int y1 = row/2-10;
	int x1 = col/4+15; 
	int y2 = 20; 
	int x2 = col/4; 

    SLsmg_gotorc (row/2-3,col/4);
    SLsmg_set_char_set (1);
	SLsmg_fill_region (y1,x1,y2-1,x2, '_');
    SLsmg_set_char_set (0);
	SLsmg_draw_box (y1,x1,y2,x2);

    SLsmg_gotorc (row/2-10,col/2-4);
    SLsmg_write_string (" Menu ");


	SLsmg_set_color (0);
	sprintf(_line,"ICE color");
    SLsmg_gotorc (row/2-9,col/2-8);
    SLsmg_write_nstring (_line, 20);

	SLsmg_set_color (51);
	sprintf(_line,"Do something ... ");
    SLsmg_gotorc (row/2-8,col/2-8);
    SLsmg_write_nstring (_line, 20);

	SLsmg_gotorc (row-2,-1);
    SLsmg_refresh ();
}


void draw_dialog_waiting(char * caption,char * file) 
{
  int row, col;
	row = SLtt_Screen_Rows;
 	col = SLtt_Screen_Cols;

	SLsmg_set_color (0);

	int y1 = row/2-3;
	int x1 = col/4; 
	int y2 = 7; 
	int x2 = col/2; 

    SLsmg_gotorc (row/2-3,col/4);
    SLsmg_set_char_set (1);
	SLsmg_fill_region (y1,x1,y2-1,x2, '_');
    SLsmg_set_char_set (0);
	SLsmg_draw_box (y1,x1,y2,x2);

    SLsmg_gotorc (row/2-1,col/4+12);
	SLsmg_write_string (caption);

    SLsmg_gotorc (row/2+1,col/4+2);
	SLsmg_write_nstring (file,row+10);

	SLsmg_gotorc (row-2,-1);
    SLsmg_refresh ();

}

void draw_dialog(bool _save , char * caption) 
{
  int  row, col;
	row = SLtt_Screen_Rows;
 	col = SLtt_Screen_Cols;

	SLsmg_set_color (51);

	int y1 = row/2-3;
	int x1 = col/4; 
	int y2 = 7; 
	int x2 = col/2; 

    SLsmg_gotorc (row/2-3,col/4);
    SLsmg_set_char_set (1);
	SLsmg_fill_region (y1,x1,y2-1,x2, '_');
    SLsmg_set_char_set (0);
	SLsmg_draw_box (y1,x1,y2,x2);

    SLsmg_gotorc (row/2-2,col/4+2);
    SLsmg_write_nstring (caption, col/2-5);

	if(_save) SLsmg_set_color (0);else SLsmg_set_color (51);
	SLsmg_gotorc (row/2,col/2-15);
	SLsmg_write_string ("    Да    ");


	if(_save) SLsmg_set_color (51);else SLsmg_set_color (0);
	SLsmg_gotorc (row/2,col/2+10);
	SLsmg_write_string ("   Нет   ");

	SLsmg_gotorc (row-2,-1);

    SLsmg_refresh ();
}


void draw_dialog_f5(bool _save , char * source , char * dest) 
{
  	char _line [512];
  	char _line2 [512];
    int  row, col;
		row = SLtt_Screen_Rows;
   	col = SLtt_Screen_Cols;

	SLsmg_set_color (51);

	int y1 = row/2-3;
	int x1 = col/4; 
	int y2 = 7; 
	int x2 = col/2; 

    SLsmg_gotorc (row/2-3,col/4);
    SLsmg_set_char_set (1);
	SLsmg_fill_region (y1,x1,y2-1,x2, '_');
    SLsmg_set_char_set (0);
	SLsmg_draw_box (y1,x1,y2,x2);

	sprintf(_line,"Копировать   %s",source);
	sprintf(_line2,"в   %s  ?",dest);

    SLsmg_gotorc (row/2-3,col/2-2);
    SLsmg_write_string ("Copy");


    SLsmg_gotorc (row/2-2,col/4+2);
    SLsmg_write_nstring (_line, col/2-5);

    SLsmg_gotorc (row/2-1,col/4+2);
    SLsmg_write_nstring (_line2, col/2-5);

	if(_save) SLsmg_set_color (0);else SLsmg_set_color (51);
	SLsmg_gotorc (row/2+1,col/2-15);
	SLsmg_write_string ("    Да    ");


	if(_save) SLsmg_set_color (51);else SLsmg_set_color (0);
	SLsmg_gotorc (row/2+1,col/2+10);
	SLsmg_write_string ("   Нет   ");

	SLsmg_gotorc (row-2,-1);

    SLsmg_refresh ();
}

void draw_dialog_f7(int y,char * caption) 
{
    int  i,row, col;
	row = SLtt_Screen_Rows;
   	col = SLtt_Screen_Cols;
    char bu [512];
	for(i=0;i<512;i++)
	{
		bu[i]=0;
	}

	SLsmg_set_color (51);

	int y1 = row/2-3;
	int x1 = col/4; 
	int y2 = 5; 
	int x2 = 60; 

    SLsmg_gotorc (row/2-3,col/4);
    SLsmg_set_char_set (1);
	SLsmg_fill_region (y1,x1,y2-1,x2, '_');
    SLsmg_set_char_set (0);
	SLsmg_draw_box (y1,x1,y2,x2);

    SLsmg_gotorc (row/2-3,col/4+20);
	SLsmg_write_string (caption);


    SLsmg_gotorc (row/2-2,col/4+2);
	SLsmg_write_string (" Наберите имя : ");

	SLsmg_set_color (1);
	SLsmg_gotorc (row/2-1,col/4+3);
	SLsmg_write_string ("                                                        ");
	SLsmg_set_color (0);

	GetCommandBuffer();
	if(ice_console.f7_pos>55) 
	{
		ice_console.f7_start = ice_console.f7_pos-55;
	}
	if(ice_console.f7_pos<ice_console.f7_start) 
	{
		ice_console.f7_start = ice_console.f7_pos;
	}


	char * cmdline_str_result22 = &ice_console.f7_buf[ice_console.f7_start];
	sprintf(bu,"%s",cmdline_str_result22);	
	SLsmg_gotorc (row/2-1,col/4+3);
	SLsmg_write_nstring (bu,56);
	if(y>55) y=55;
	SLsmg_gotorc (row/2-1,col/4+3+y);
    SLsmg_refresh ();
}

void draw_dialog_f9(char * caption) 
{
	int i = 0;
 	char _line [512];
  int  row, col;
	int inc=0;
	int _y[]= {5,6,9,10,11,12,13};
	char *name[] = {" Полный список "," Краткий список "," По имени "," По расширению "," По дате "," По размеру "," Реверс "}; 


	row = SLtt_Screen_Rows;
   	col = SLtt_Screen_Cols;

	if(cur==&right) 
	{
		inc = col/2;
		sprintf(_line," Настройки правой панели ");
	}
	else
	{
		sprintf(_line," Настройки левой панели ");
	}

	SLsmg_set_color (51);

	int y2 = 20; 
	int x2 = 32; 

    SLsmg_gotorc (2,2+inc);
    SLsmg_set_char_set (1);
	SLsmg_fill_region (2,2+inc,y2-1,x2, '_');
    SLsmg_set_char_set (0);
	SLsmg_draw_box (2,2+inc,y2,x2);

    SLsmg_gotorc (2,5+inc);
	SLsmg_write_string (_line);


	sprintf(_line," ------ Внешний вид ------");
    SLsmg_gotorc (4,4+inc);
    SLsmg_write_nstring (_line, 28);

	sprintf(_line," ------ Сортировка ------");
    SLsmg_gotorc (8,4+inc);
    SLsmg_write_nstring (_line, 28);

	for(i=0;i<7;i++)
	{
		if(i==cur_panel->pos_menu)
		{
			SLsmg_set_color (0);
		}
		else
		{
			SLsmg_set_color (51);
		}	
		sprintf(_line,name[i]);
    	SLsmg_gotorc (_y[i],4+inc);
    	SLsmg_write_nstring (_line, 28);

		if(i==cur_panel->list_type)
		{
			SLsmg_gotorc (_y[i],3+inc);
			SLsmg_write_string ("*");
		}

		if(i==cur_panel->sort_type+2)
		{
			SLsmg_gotorc (_y[i],3+inc);
			SLsmg_write_string ("*");
		}

		if(cur_panel->reverse && i==6)
		{
			SLsmg_gotorc (_y[i],3+inc);
			SLsmg_write_string ("*");
		}
	}

	SLsmg_gotorc (row-2,-1);
    SLsmg_refresh ();
}


void draw_command_line(int cursor) 
{
  int  i,row, col;
	row = SLtt_Screen_Rows;
 	col = SLtt_Screen_Cols;
  char bu [1024];
	for(i=0;i<1024;i++)
	{
		bu[i]=0;
	}

	SLsmg_set_color (1);

	SLsmg_set_color (1);
	SLsmg_gotorc (row-2,0);
	SLsmg_write_nstring (" ",col);
	SLsmg_set_color (1);

	GetMainCommandBuffer();
	if(ice_console.pos>=col) 
	{
		ice_console.start = ice_console.pos-col;
	}
	if(ice_console.pos<ice_console.start) 
	{
		ice_console.start = ice_console.pos;
	}

	char * cmdline_str_result22 = &ice_console.main_buf[ice_console.start];
	sprintf(bu,"%s",cmdline_str_result22);	
	SLsmg_gotorc (row-2,0);
	SLsmg_write_string (bu);
	SLsmg_gotorc (row-2,cursor);
    SLsmg_refresh ();
}


int height()
{
  int rows = SLtt_Screen_Rows  ;
	return rows -7;
}


void drawleft (struct dir *c,bool is_vfs)  
{
	drawleftpanel (1, &c->cat[c->topfile], c->num, c,is_vfs);
}


void drawright (struct dir *c,bool is_vfs)    /* redraw window */
{
	drawrightpanel (1, &c->cat[c->topfile], c->num, c,is_vfs);
}

void DisplayPanels()
{

   int  r, c, dr, dc, row, col;
   dr=dc=0;
   char _line [100];
   row = (SLtt_Screen_Rows - (int)dr)/2;
   col = (SLtt_Screen_Cols - (int)dc)/2;

   // while(demolib_init_terminal (1, 1) < 0);
   if (-1 == demolib_init_terminal (1, 1))     return ;
   SLtt_set_color (0, NULL, "white", color_scheme.ice_color);
   
   r = SLtt_Screen_Rows  ;
   c = SLtt_Screen_Cols  ;

    SLsmg_gotorc (r-1, 0);
    SLsmg_set_color (44);
	SLsmg_write_string (" F1 Help ");
    SLsmg_gotorc (r-1, 10);
	SLsmg_write_string(" F2 Menu ");
    SLsmg_gotorc (r-1, 20);
	SLsmg_write_string(" F3 View ");
    SLsmg_gotorc (r-1, 30);
	SLsmg_write_string(" F4 Edit ");
    SLsmg_gotorc (r-1, 40);
	SLsmg_write_string(" F5 Copy ");
    SLsmg_gotorc (r-1, 50);
	SLsmg_write_string(" F6 Move ");
    SLsmg_gotorc (r-1, 60);
	SLsmg_write_string(" F7 MkDir ");
    SLsmg_gotorc (r-1, 71);
	SLsmg_write_string(" F9 Panel ");
    SLsmg_gotorc (r-1, 82);
	SLsmg_write_string(" F9 Panel ");
    SLsmg_gotorc (r-1, 93);
	SLsmg_write_string(" F10 Quit ");

	SLsmg_set_color (0);


	if(panel_left.list_type==0)  
	{
		if(ice_vfs_left.is_vfs)	drawleft (&vfs_left,ice_vfs_left.is_vfs); else 	drawleft (&left,ice_vfs_left.is_vfs);  
	}
	else
	{
		if(ice_vfs_left.is_vfs)	drawright (&vfs_left,ice_vfs_left.is_vfs);  else 	drawright (&left,ice_vfs_left.is_vfs);  
	}
	
	if(panel_right.list_type==0)  
	{
		if(ice_vfs_right.is_vfs)	drawleft (&vfs_right,ice_vfs_right.is_vfs); else 	drawleft (&right,ice_vfs_right.is_vfs);  
	}
	else
	{
		if(ice_vfs_right.is_vfs)	
		{
			drawright (&vfs_right,ice_vfs_right.is_vfs);  
		}
		else 	drawright (&right,ice_vfs_right.is_vfs);  
	}



//	if(panel_left.list_type==0)  drawleft (&left,panel_left.is_vfs);  else drawright (&left,panel_left.is_vfs);
//	if(panel_right.list_type==0) drawleft (&right,panel_right.is_vfs); else drawright (&right,panel_right.is_vfs);

	SLsmg_set_color (0);
	if(left_count_tag>0 && (cur==&left || cur==&vfs_left))
	{
		sprintf(_line," Выделено: %d файлов   %d  байт",left_count_tag , (int)cur->tbytes);
		SLsmg_gotorc (r-4, 2);
		SLsmg_write_nstring(_line,c/2-10);
	}
	if(right_count_tag>0  && (cur==&right || cur==&vfs_right))
	{
		sprintf(_line,"Выделено: %ld файлов   %ld  байт",(long)right_count_tag, cur->tbytes);
		SLsmg_gotorc (r-4, c/2+2);
		SLsmg_write_nstring(_line,c/2-10);
	}

//	SLsmg_erase_eol ();

/*
	int count=0;
	for(i=0;i<35;i++)
	{
		SLsmg_set_color (count);
    	SLsmg_gotorc (i+2,c/2+2);
		SLsmg_write_string ("1234567890");
		SLsmg_set_color (0);
		count++;
	}

	for(i=0;i<35;i++)
	{
		SLsmg_set_color (count);
    	SLsmg_gotorc (i+2,c/2+13);
		SLsmg_write_string ("1234567890");
		SLsmg_set_color (0);
		count++;
	}

	for(i=0;i<35;i++)
	{
		SLsmg_set_color (count);
    	SLsmg_gotorc (i+2,c/2+24);
		SLsmg_write_string ("1234567890");
		SLsmg_set_color (0);
		count++;
	}

	for(i=0;i<35;i++)
	{
		SLsmg_set_color (count);
    	SLsmg_gotorc (i+2,c/2+35);
		SLsmg_write_string ("1234567890");
		SLsmg_set_color (0);
		count++;
	}
*/


	SLsmg_set_color (0);
   	SLsmg_gotorc (1,5);
	if(strlen(left.cwd)>(c/2-5))
	{
		if(ice_vfs_left.is_vfs)	
			SLsmg_write_nstring (ice_vfs_left.file_name,c/2-5);
		else
			SLsmg_write_nstring (left.cwd,c/2-5);
	}	
	else
	{
		if(ice_vfs_left.is_vfs)	
			SLsmg_write_nstring (ice_vfs_left.file_name,strlen(ice_vfs_left.file_name));
		else
			SLsmg_write_nstring (left.cwd,strlen(left.cwd));
	}
   	SLsmg_gotorc (1,c/2+5);


	if(ice_vfs_right.is_vfs)	
		SLsmg_write_nstring (ice_vfs_right.file_name,strlen(ice_vfs_right.file_name));
	else
		SLsmg_write_nstring (right.cwd,strlen(right.cwd));

	draw_command_line(ice_console.pos); 

  SLsmg_refresh ();

}



