#include <stdio.h>
#include <stdlib.h>
#include "../ice.h"
#include "../dir.h"
#include <syslog.h>

static struct dir *compdir;

void ice_vfs_Push(struct vfs_node ** head , 
						long size, 
						char * name,
						time_t mtime)
{
	struct vfs_node * new = malloc(sizeof(struct vfs_node));
	new->size=size;
	sprintf(new->name,"%s",name);
	new->mtime=mtime;
	new->next=*head;
	*head=new;
	vfs_cur->len++;
}

void ice_vfs_f5_Push(struct vfs_node_f5 ** head , 
											char * source,
											char * target)
{
	struct vfs_node_f5 * new = malloc(sizeof(struct vfs_node_f5));
	sprintf(new->source,"%s",source);
	sprintf(new->target,"%s",target);
	new->next=*head;
	*head=new;
}

void ice_vfs_f5_dir_Push(struct vfs_path ** head , char * name)
{
	struct vfs_path * new = malloc(sizeof(struct vfs_path));
	sprintf(new->name,"%s",name);
	new->next=*head;
	*head=new;
}

void ice_vfs_path_Push(struct vfs_path ** head , char * name)
{
	struct vfs_path * new = malloc(sizeof(struct vfs_path));
	sprintf(new->name,"%s",name);
	new->next=*head;
	*head=new;
	vfs_cur->len_path++;
	char * _vfs_Path_Dir = malloc(sizeof(vfs_cur->Path_Dir)+sizeof(vfs_cur->Path_Dir)+2);
	sprintf(_vfs_Path_Dir,"%s%s",vfs_cur->Path_Dir,name);
	vfs_cur->Path_Dir=_vfs_Path_Dir;
}

void ice_vfs_path_Pop(struct vfs_path ** head)
{
	struct vfs_path * temp = *head;
	char * path = malloc(sizeof(temp->name));
	sprintf(path,"%s",temp->name);
	*head = temp->next;
	free(temp);
	vfs_cur->len_path--;

    int len = strlen(vfs_cur->Path_Dir)-strlen(path);
	char * _temp1 = vfs_cur->Path_Dir;
	_temp1 += len;
	*_temp1 = '\0';

}


//    
int vfs_strchr(char *s, char c)
{
	int count=0;
    while (*s  != '\0')  
	{
		vfs_cur->endian_char=FALSE;		
		if(*s==c)		
		{
			count++;
			vfs_cur->endian_char=TRUE;		
		}
		s++;
	}

    return count;
}


//   
int vfs_strchr2(char *s, char c)
{
	int count=0;
	int result=0;
	vfs_cur->del_count=0;
  while (*s  != '\0')  
	{
		vfs_cur->endian_char=FALSE;		
		if(*s==c)
		{
			vfs_cur->endian_char=TRUE;		
			vfs_cur->del_count++;
			result=count;
		}
		s++;
		count++;
	}

    return result;
}



char* vfs_strstr ( char* str, char* pattern )
{
	char* temp = NULL;
	char* temp2 = str;
	int length =  strlen ( pattern );
	while ( *str !='\0' ) 
	{
		if ( !strncmp ( str, pattern, ( length ) ) ) 
			temp = str;
			break;
	}

	if(temp==temp2 && strcmp(temp,temp2)==0)
	{
		vfs_cur->endian_char=FALSE;		
		temp2 += strlen(pattern);
		int exists = vfs_strchr(temp2,'/');
		if(exists==0 || (vfs_cur->endian_char && exists==1))
		{
			temp=temp2;
		}
		else temp = NULL;

	}
	return  temp ;
}

void ice_vfs_Subdir_Push(struct vfs_node * head ,  char * dir_name)
{
	struct vfs_node * current = head;
	
	if(strcmp(dir_name,"/")==0) // root
	{
		int exists = vfs_strchr(current->name,'/');
		if(exists==0 || (vfs_cur->endian_char && exists==1))
		{
			ice_vfs_Push(&vfs_cur->List_Subdir , 
						current->size, 
						current->name,
						current->mtime);		
			vfs_cur->len_subdir++;
		}
	}
	else
	{
		vfs_cur->other_dir=FALSE;
		char * str_exists = vfs_strstr(current->name,dir_name);
		if(str_exists !=NULL && strcmp(str_exists,"") !=0)
		{
			ice_vfs_Push(&vfs_cur->List_Subdir , 
						current->size, 
						str_exists,
						current->mtime);		
			vfs_cur->len_subdir++;
		}

	}
}


int vfs_get_subdir_name(char * name) 
{
	int result = 0 ;
	struct vfs_node * current = vfs_cur->List;
	while(current !=NULL)
	{
		if(strcmp(name,current->name)==0)
		{
			result=1;
			break;	
		}
		current=current->next;
		if(current==vfs_cur->List) break;
	}
	return result;
}

char * my_substr ( char* str, int len )
{
	char* temp = malloc(sizeof(char)*(len+1));
	char* _temp = temp;
	while ( *str !='\0' ) 
	{
		*temp = *str;
		str++;
		temp++;
		len--;
		if(len==0)break;
	}
	*temp='\0';
	return ( _temp );
}

void vfs_get_bad_subdir() 
{
	struct vfs_node * current = vfs_cur->List;
	char dir[512];
	while(current !=NULL)
	{
		int exists = vfs_strchr2(current->name,'/');
		if(exists>0 ) sprintf(dir,"%s",my_substr(current->name,exists+1));
		else sprintf(dir,"");
		int result = vfs_get_subdir_name(dir);
		if(result==0) 
		{
			ice_vfs_Push(&vfs_cur->List, 0,dir,current->mtime);
		}
		current=current->next;
		if(current==vfs_cur->List) break;
	}
}

void vfs_get_subdir(char * dir_name) 
{
	struct vfs_node * current = vfs_cur->List;
	while(current !=NULL)
	{
		ice_vfs_Subdir_Push(current,dir_name);
		current=current->next;
		if(current==vfs_cur->List) break;
	}

	if((vfs_cur->len_subdir==0) && (strcmp(dir_name,"/")==0))
	{
		vfs_get_bad_subdir(); 
		struct vfs_node * current = vfs_cur->List;
		while(current !=NULL)
		{
			ice_vfs_Subdir_Push(current,dir_name);
			current=current->next;
			if(current==vfs_cur->List) break;
		}
	}
}


void vfs_get_subdir_f5(char * dir_name,char * target_dir,char * dir) 
{
	struct vfs_node * current = vfs_cur->List;
	int length =  strlen ( dir_name );
	char * target = malloc(512);
	char * temp,* temp2;
	char path[1024];
	vfs_cur->List_Dir_F5=NULL;

	while(current !=NULL)
	{
		if ( strncmp ( current->name, dir_name, length  ) ==0 && current->name !=NULL) 
		{
				int is_dir = vfs_strchr(current->name,'/');
				if(vfs_cur->endian_char)
				{
					temp=current->name;
					temp += length;
				  sprintf(path,"%s%s",target_dir,temp);
					ice_vfs_f5_dir_Push(&vfs_cur->List_Dir_F5 , path);
				}
		}
			current=current->next;
			if(current==vfs_cur->List) break;
	}
}

void vfs_get_subdir_files_f5(char * dir_name,char * target_dir,char * dir) 
{
	struct vfs_node * current = vfs_cur->List;
	int length =  strlen ( dir_name );
	char * target = malloc(512);
	char * temp;
	char path[1024];
  vfs_cur->List_F5=NULL;

	while(current !=NULL)
	{
		if ( strncmp ( current->name, dir_name, length  ) ==0 && current->name !=NULL) 
		{
				temp=current->name;
				temp += length;
				int exists = vfs_strchr2(temp,'/');
				snprintf(path,exists+1,"%s",temp);
				if(!vfs_cur->endian_char)
				{
					if(strlen(dir)>1) sprintf(target,"%s/%s%s",dir,target_dir,path);
					else 	sprintf(target,"%s%s",target_dir,path);
					ice_vfs_f5_Push(&vfs_cur->List_F5 , current->name,target);
				}
			}
			current=current->next;
			if(current==vfs_cur->List) break;
	}
}


int Print_List(struct vfs_node *head)
{
	struct vfs_node * current = head;
	while(current !=NULL)
	{
		current=current->next;
		if(current==head) break;
	}
	return 0 ;
}
	
char * get_vfs_path_f5(struct vfs_path * head , char * name, int filetype)
{
	struct vfs_path * current = head;

	char * result  = malloc(1024);
	char * _result = malloc(1024);
	int len_path = vfs_cur->len_path;
	vfs_cur->f5_root = malloc(512);
	if(len_path==1) 
	{
		if(filetype=='/') return "";
		else return name;
	}	

	int count=0;
	while(current !=NULL)
	{
		if(len_path>1)	
		{
			if(count==0)
				sprintf(result,"%s",current->name);
			else
			{
				sprintf(_result,"%s%s",current->name,result);
				sprintf(result,"%s",_result);
				sprintf(vfs_cur->f5_root,"%s",current->name);
			}
			len_path--;
		}

		count++;
		current=current->next;
		if(current==head) break;
	}

	return result ;
}



void ice_vfs_Post_Add_Tar(int del_count,char * name)
{
	struct vfs_node * current   = vfs_cur->List;
	struct vfs_node * current2  = vfs_cur->List_Subdir;
	struct vfs_node * add       = NULL;
	struct vfs_node * add0      = NULL;
	int found;	
	char dir[512];

	while(current !=NULL)
	{
		found=0;
		int exists = vfs_strchr2(current->name,'/');
		if(exists>0 && del_count==vfs_cur->del_count) sprintf(dir,"%s",my_substr(current->name,exists+1));
		else sprintf(dir,"");

		while(add !=NULL)
		{
			if(exists>0)
			{
				if ( strncmp ( add->name, dir , exists+1 ) ==0) 
				{
					found=1;
					break;
				}
			}
			if(add->next==NULL) break;
			add=add->next;
		}

		if(found==0 && strcmp(dir,"")!=0)
		{
			ice_vfs_Push(&add0, current->size,dir,current->mtime);
			char * str_exists = vfs_strstr(dir,name);
			ice_vfs_Push(&vfs_cur->List_Subdir, current->size,str_exists,current->mtime);
		}
		add=add0;
		current=current->next;
		if(current==vfs_cur->List) break;
	}

 
}


void vfs_setdir (struct dir *d, 
				char *dirname,
				struct vfs_node * head)
{
	int cat_size=vfs_cur->len;
	register struct file *p;
	int _vfs_strchr=0;

	d->cat = (struct file*) calloc (cat_size+1, sizeof (struct file));

	d->num = 0;
	d->nfiles = 0;
	d->tfiles = 0;
	d->nbytes = 0;
	d->mfiles = 0;
	d->mbytes = 0;


	p = &d->cat[0];
	p->tag = 0;
	p->info = 0;
	p->rinfo = 0;
	p->infodate = 0;
	p->infoflag = 0;
	p->dateflag = 0;
	strcpy (p->name, "..");
	++d->num;

	struct vfs_node * current = head;
	while(current !=NULL)
	{
		p = &d->cat[d->num];
		strncpy (p->name, current->name, sizeof(current->name)-1);
		p->size = (int)current->size;
		p->mode=S_IFREG;
		
		_vfs_strchr = vfs_strchr(p->name,'/');
		if(vfs_cur->endian_char) p->mode=S_IFDIR;

		p->mtime = current->mtime;
		

		p->tag = 0;
		p->info = 0;
		p->rinfo = 0;
		p->infodate = 0;
		p->infoflag = 0;
		p->dateflag = 0;

		current=current->next;
		if(current==head) break;
		++d->num;
	}

	d->topfile = d->curfile = 0;
	compdir = d;
	qsort ((char*)d->cat, (unsigned) d->num, sizeof (d->cat[0]), compfile);

}

void ice_vfs_init(char * cwd)
{
	 vfs_cur->List = NULL;
	 vfs_cur->List_Subdir = NULL ;
	 vfs_cur->Path = NULL ;
	 vfs_cur->len=0;
	 vfs_cur->len_subdir=0;
	 vfs_cur->len_path=0;
	 ice_vfs_path_Push(&vfs_cur->Path , cwd);
	 vfs_cur->Path_Dir="";
}


void ice_vfs_Add(long size,char * name,time_t mtime)
{
	ice_vfs_Push(&vfs_cur->List, size,name,mtime);
}

